"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventEmitter = void 0;
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
const tsyringe_1 = require("tsyringe");
const AgentConfig_1 = require("./AgentConfig");
let EventEmitter = class EventEmitter {
    constructor(agentConfig) {
        this.agentConfig = agentConfig;
        this.eventEmitter = new agentConfig.agentDependencies.EventEmitterClass();
    }
    emit(data) {
        this.eventEmitter.emit(data.type, data);
    }
    on(event, listener) {
        this.eventEmitter.on(event, listener);
    }
    off(event, listener) {
        this.eventEmitter.off(event, listener);
    }
    observable(event) {
        return rxjs_1.fromEventPattern((handler) => this.on(event, handler), (handler) => this.off(event, handler)).pipe(operators_1.takeUntil(this.agentConfig.stop$));
    }
};
EventEmitter = __decorate([
    tsyringe_1.scoped(tsyringe_1.Lifecycle.ContainerScoped),
    __metadata("design:paramtypes", [AgentConfig_1.AgentConfig])
], EventEmitter);
exports.EventEmitter = EventEmitter;
//# sourceMappingURL=EventEmitter.js.map