import type { CredReq } from 'indy-sdk';
import { AgentMessage } from '../../../../../agent/AgentMessage';
import { Attachment } from '../../../../../decorators/attachment/Attachment';
export declare const INDY_CREDENTIAL_REQUEST_ATTACHMENT_ID = "libindy-cred-request-0";
interface RequestCredentialMessageOptions {
    id?: string;
    comment?: string;
    requestAttachments: Attachment[];
    attachments?: Attachment[];
}
export declare class V1RequestCredentialMessage extends AgentMessage {
    constructor(options: RequestCredentialMessageOptions);
    readonly type: string;
    static readonly type: import("../../../../../utils/messageType").ParsedMessageType;
    comment?: string;
    messageAttachment: Attachment[];
    get indyCredentialRequest(): CredReq | null;
    getAttachmentById(id: string): Attachment | undefined;
}
export {};
