import type { AgentConfig } from '../../../../../agent/AgentConfig';
import type { Handler } from '../../../../../agent/Handler';
import type { InboundMessageContext } from '../../../../../agent/models/InboundMessageContext';
import type { DidCommMessageRepository } from '../../../../../storage';
import type { V2CredentialService } from '../V2CredentialService';
import { V2IssueCredentialMessage } from '../messages/V2IssueCredentialMessage';
export declare class V2IssueCredentialHandler implements Handler {
    private credentialService;
    private agentConfig;
    private didCommMessageRepository;
    supportedMessages: (typeof V2IssueCredentialMessage)[];
    constructor(credentialService: V2CredentialService, agentConfig: AgentConfig, didCommMessageRepository: DidCommMessageRepository);
    handle(messageContext: InboundMessageContext<V2IssueCredentialMessage>): Promise<import("../../../../../types").OutboundMessage<import("../messages/V2CredentialAckMessage").V2CredentialAckMessage> | import("../../../../../types").OutboundServiceMessage<import("../messages/V2CredentialAckMessage").V2CredentialAckMessage> | undefined>;
    private createAck;
}
