import type { GenericRecordTags, SaveGenericRecordOption } from '../repository/GenericRecord';
import { GenericRecord } from '../repository/GenericRecord';
import { GenericRecordsRepository } from '../repository/GenericRecordsRepository';
export declare class GenericRecordService {
    private genericRecordsRepository;
    constructor(genericRecordsRepository: GenericRecordsRepository);
    save({ content, tags }: SaveGenericRecordOption): Promise<GenericRecord>;
    delete(record: GenericRecord): Promise<void>;
    update(record: GenericRecord): Promise<void>;
    findAllByQuery(query: Partial<GenericRecordTags>): Promise<GenericRecord[]>;
    findById(id: string): Promise<GenericRecord | null>;
    getAll(): Promise<GenericRecord[]>;
}
