"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonTransformer = void 0;
const class_transformer_1 = require("class-transformer");
class JsonTransformer {
    static toJSON(classInstance) {
        return class_transformer_1.instanceToPlain(classInstance, {
            exposeDefaultValues: true,
        });
    }
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    static fromJSON(json, Class) {
        return class_transformer_1.plainToInstance(Class, json, { exposeDefaultValues: true });
    }
    static clone(classInstance) {
        return class_transformer_1.instanceToInstance(classInstance, {
            exposeDefaultValues: true,
            enableCircularCheck: true,
            enableImplicitConversion: true,
            ignoreDecorators: true,
        });
    }
    static serialize(classInstance) {
        return JSON.stringify(this.toJSON(classInstance));
    }
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    static deserialize(jsonString, Class) {
        return this.fromJSON(JSON.parse(jsonString), Class);
    }
}
exports.JsonTransformer = JsonTransformer;
//# sourceMappingURL=JsonTransformer.js.map